// This is https://github.com/aws/aws-sdk-go-v2/blob/a2b751d1ba71f59175a41f9cae5f159f1044360f/aws/signer/internal/v4/scope.go

package v4

import "strings"

// BuildCredentialScope builds the Signature Version 4 (SigV4) signing scope
func BuildCredentialScope(signingTime SigningTime, region, service string) string {
	return strings.Join([]string{
		signingTime.ShortTimeFormat(),
		region,
		service,
		"aws4_request",
	}, "/")
}
