//go:build !loghttp

package middleware

import (
	"net/http"

	"git.frostfs.info/TrueCloudLab/frostfs-s3-gw/internal/logs"
	"go.uber.org/zap"
)

type (
	LogHTTPSettings interface {
		LogHTTPConfig() LogHTTPConfig
	}
	LogHTTPConfig struct {
		Enabled    bool
		MaxBody    int64
		MaxLogSize int
		OutputPath string
		UseGzip    bool
	}
)

func LogHTTP(l *zap.Logger, _ LogHTTPSettings) Func {
	l.Warn(logs.LogHTTPDisabledInThisBuild, logs.TagField(logs.TagApp))
	return func(h http.Handler) http.Handler {
		return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
			h.ServeHTTP(w, r)
		})
	}
}

func (*LogHTTPConfig) InitHTTPLogger(*zap.Logger) {
	// ignore
}
